package com.widget.imagevideobanner.log;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Environment;
import android.text.TextUtils;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.nio.charset.StandardCharsets;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * 日志打印
 */
public class FileUtils {

    @SuppressLint("SimpleDateFormat")
    private static final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    public static void writeFileLog(String filePath, String input) {
        if (TextUtils.isEmpty(input)) {
            return;
        }
        input = sdf.format(new Date()) + input + "\n";

        FileOutputStream fos = null;
        OutputStreamWriter writer = null;
        try {
            File logFile = new File(filePath);
            if (!logFile.exists() && !logFile.createNewFile()) return;
            fos = new FileOutputStream(logFile, true);
            writer = new OutputStreamWriter(fos, StandardCharsets.UTF_8);
            writer.write(input);
            writer.flush();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (null != fos) {
                try {
                    fos.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (null != writer) {
                try {
                    writer.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    public static File getDownloadDir(Context context) {
        File downloadDir = null;
        if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)) {
            if( context.getExternalCacheDir() != null){
                downloadDir = new File(context.getExternalCacheDir(), "VIDEO-AD");
            }
        } else {
            if( context.getCacheDir() != null){
                downloadDir = new File(context.getCacheDir(), "VIDEO-AD");
            }
        }
        if(downloadDir == null){
            downloadDir= new File( Environment.getExternalStorageDirectory().getAbsolutePath(),"VIDEO-AD");
        }
        if (!downloadDir.exists()) {
            downloadDir.mkdirs();
        }
        return downloadDir;
    }

}
