package com.widget.imagevideobanner.view;

import android.content.Context;
import android.support.annotation.NonNull;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.FrameLayout;

import com.shuyu.gsyvideoplayer.listener.GSYSampleCallBack;
import com.shuyu.gsyvideoplayer.render.effect.AutoFixEffect;
import com.shuyu.gsyvideoplayer.render.effect.BarrelBlurEffect;
import com.shuyu.gsyvideoplayer.render.effect.BlackAndWhiteEffect;
import com.shuyu.gsyvideoplayer.render.effect.BrightnessEffect;
import com.shuyu.gsyvideoplayer.render.effect.ContrastEffect;
import com.shuyu.gsyvideoplayer.render.effect.CrossProcessEffect;
import com.shuyu.gsyvideoplayer.render.effect.DocumentaryEffect;
import com.shuyu.gsyvideoplayer.render.effect.FillLightEffect;
import com.shuyu.gsyvideoplayer.render.effect.GammaEffect;
import com.shuyu.gsyvideoplayer.render.effect.GaussianBlurEffect;
import com.shuyu.gsyvideoplayer.render.effect.GrainEffect;
import com.shuyu.gsyvideoplayer.render.effect.HueEffect;
import com.shuyu.gsyvideoplayer.render.effect.InvertColorsEffect;
import com.shuyu.gsyvideoplayer.render.effect.LamoishEffect;
import com.shuyu.gsyvideoplayer.render.effect.NoEffect;
import com.shuyu.gsyvideoplayer.render.effect.OverlayEffect;
import com.shuyu.gsyvideoplayer.render.effect.PosterizeEffect;
import com.shuyu.gsyvideoplayer.render.effect.SampleBlurEffect;
import com.shuyu.gsyvideoplayer.render.effect.SaturationEffect;
import com.shuyu.gsyvideoplayer.render.effect.SepiaEffect;
import com.shuyu.gsyvideoplayer.render.effect.SharpnessEffect;
import com.shuyu.gsyvideoplayer.render.effect.TemperatureEffect;
import com.shuyu.gsyvideoplayer.render.effect.VignetteEffect;
import com.shuyu.gsyvideoplayer.render.view.GSYVideoGLView;
import com.shuyu.gsyvideoplayer.utils.GSYVideoType;
import com.widget.imagevideobanner.R;
import com.widget.imagevideobanner.bean.MediaBean;
import com.widget.imagevideobanner.log.BLogUtil;
import com.widget.imagevideobanner.player.CustomBlurEffect;
import com.widget.imagevideobanner.player.GSYVideoGLViewCustomRender4;
import com.widget.imagevideobanner.player.IPlayTarget;

public class VideoSubView extends FrameLayout implements IPlayTarget {

    private OnActionFinishListener mOnPageChangedListener;
    private SampleCoverVideo player;
    private MediaBean mediaBean;
    private float deep = 0.8f;


    private final GSYSampleCallBack sampleCallBack = new GSYSampleCallBack(){
        @Override
        public void onAutoComplete(String url, Object... objects) {
            super.onAutoComplete(url, objects);
            BLogUtil.log("当前视频播放完毕，切换下一帧");
            if(null != mOnPageChangedListener){
                mOnPageChangedListener.next();
            }
        }
    };

    public VideoSubView(@NonNull Context context) {
        super(context);
    }

    public VideoSubView(@NonNull Context context, MediaBean mediaBean, final OnActionFinishListener onPageChangedListener) {
        super(context);
        this.mediaBean = mediaBean;
        mOnPageChangedListener = onPageChangedListener;
        View parent = LayoutInflater.from(context).inflate(R.layout.layout_player_view, this, true);
        player = parent.findViewById(R.id.player);
        player.getBackButton().setVisibility(View.GONE);
        player.setAutoFullWithSize(true);
        player.setVideoAllCallBack(sampleCallBack);
        player.loadCoverImage(mediaBean.getCover(),0);
        player.setUp(mediaBean.getUrl(), true, null);
        player.setEffectFilter(new BarrelBlurEffect());
//        player.setEffectFilter(new GaussianBlurEffect(6.0f, GaussianBlurEffect.TYPEXY));
        player.setCustomGLRenderer(new GSYVideoGLViewCustomRender4());
        GSYVideoType.setRenderType(GSYVideoType.GLSURFACE);
        player.setGLRenderMode(GSYVideoGLView.MODE_RENDER_SIZE);
        player.setLooping(mediaBean.isLooping());
        BLogUtil.log("设置视频轮播是否循环模式="+mediaBean.isLooping());
    }

    @Override
    public void onActive() {
        BLogUtil.log("视频开始播放");
        if(null != mediaBean){
            // 必须得在播放之前设置循环模式
            player.setLooping(mediaBean.isLooping());
            BLogUtil.log("设置视频轮播是否循环模式onActive="+mediaBean.isLooping());
        }
        player.startPlayLogic();
    }

    @Override
    public void inActive() {
        BLogUtil.log("视频暂停播放");
        try {
           player.onVideoReset();
        }catch (Throwable e){
            BLogUtil.log("停止视频播放出错 "+e.getLocalizedMessage());
        }
    }

}
